package com.mygdx.game;

import com.badlogic.gdx.ApplicationAdapter;
import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Net;
import com.badlogic.gdx.graphics.GL20;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;
import com.badlogic.gdx.net.ServerSocket;
import com.badlogic.gdx.net.ServerSocketHints;
import com.badlogic.gdx.net.Socket;
import com.badlogic.gdx.net.SocketHints;
import com.badlogic.gdx.utils.GdxRuntimeException;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class MyGdxGame extends ApplicationAdapter {
	SpriteBatch batch;
	Texture img;
	
	@Override
	public void create () {
		batch = new SpriteBatch();
		img = new Texture("badlogic.jpg");

		startSocket();
	}

	@Override
	public void render () {
		Gdx.gl.glClearColor(1, 0, 0, 1);
		Gdx.gl.glClear(GL20.GL_COLOR_BUFFER_BIT);
		batch.begin();
		batch.draw(img, 0, 0);
		batch.end();
	}
	
	@Override
	public void dispose () {
		batch.dispose();
		img.dispose();
	}

	public void startSocket() {
		// setup a server thread where we wait for incoming connections
		// to the server
		new Thread(new Runnable() {
			@Override
			public void run() {
				ServerSocketHints hints = new ServerSocketHints();
				ServerSocket server = Gdx.net.newServerSocket(Net.Protocol.TCP, 9999, hints);
				// wait for the next client connection
				Socket client = server.accept(null);
				// read message and send it back
				try {
					String message = new BufferedReader(new InputStreamReader(client.getInputStream())).readLine();
					Gdx.app.log("PingPongSocketExample", "got client message: " + message);
					client.getOutputStream().write("PONG\n".getBytes());
				} catch (IOException e) {
					Gdx.app.log("PingPongSocketExample", "an error occured", e);
				}
			}
		}).start();

		// create the client send a message, then wait for the
		// server to reply
		SocketHints hints = new SocketHints();
		Socket client = Gdx.net.newClientSocket(Net.Protocol.TCP, "localhost", 9999, hints);
		try {
			client.getOutputStream().write("PING\n".getBytes());
			String response = new BufferedReader(new InputStreamReader(client.getInputStream())).readLine();
			Gdx.app.log("PingPongSocketExample", "got server message: " + response);
		} catch (IOException e) {
			Gdx.app.log("PingPongSocketExample", "an error occured", e);
		}
	}
}
